Repository: endurox-dev/endurox
Branch: master
Commit: 8eac94dbe90e
Files: 38
Total size: 77.5 KB
Directory structure:
gitextract_ynbbc8ti/
├── .git/
│ ├── HEAD
│ ├── config
│ ├── description
│ ├── hooks/
│ │ ├── applypatch-msg.sample
│ │ ├── commit-msg.sample
│ │ ├── fsmonitor-watchman.sample
│ │ ├── post-update.sample
│ │ ├── pre-applypatch.sample
│ │ ├── pre-commit.sample
│ │ ├── pre-merge-commit.sample
│ │ ├── pre-push.sample
│ │ ├── pre-rebase.sample
│ │ ├── pre-receive.sample
│ │ ├── prepare-commit-msg.sample
│ │ ├── push-to-checkout.sample
│ │ ├── sendemail-validate.sample
│ │ └── update.sample
│ ├── index
│ ├── info/
│ │ └── exclude
│ ├── logs/
│ │ ├── HEAD
│ │ └── refs/
│ │ ├── heads/
│ │ │ └── master
│ │ └── remotes/
│ │ └── origin/
│ │ └── HEAD
│ ├── objects/
│ │ └── pack/
│ │ ├── pack-ac0e6b253efd0968978b6cfa07966fb2fd6c8472.idx
│ │ ├── pack-ac0e6b253efd0968978b6cfa07966fb2fd6c8472.pack
│ │ ├── pack-ac0e6b253efd0968978b6cfa07966fb2fd6c8472.promisor
│ │ ├── pack-ac0e6b253efd0968978b6cfa07966fb2fd6c8472.rev
│ │ ├── pack-b7dd7c6b8faf35a4d673846f8e7cf364a2d6e697.idx
│ │ ├── pack-b7dd7c6b8faf35a4d673846f8e7cf364a2d6e697.pack
│ │ ├── pack-b7dd7c6b8faf35a4d673846f8e7cf364a2d6e697.promisor
│ │ └── pack-b7dd7c6b8faf35a4d673846f8e7cf364a2d6e697.rev
│ ├── packed-refs
│ ├── refs/
│ │ ├── heads/
│ │ │ └── master
│ │ └── remotes/
│ │ └── origin/
│ │ └── HEAD
│ └── shallow
├── .gitignore
├── CMakeLists.txt
├── README.md
└── cmake_uninstall.cmake.in
================================================
FILE CONTENTS
================================================
================================================
FILE: .git/HEAD
================================================
ref: refs/heads/master
================================================
FILE: .git/config
================================================
[core]
repositoryformatversion = 1
filemode = true
bare = false
logallrefupdates = true
[remote "origin"]
url = https://github.com/endurox-dev/endurox
tagOpt = --no-tags
fetch = +refs/heads/master:refs/remotes/origin/master
promisor = true
partialclonefilter = blob:limit=1048576
[branch "master"]
remote = origin
merge = refs/heads/master
================================================
FILE: .git/description
================================================
Unnamed repository; edit this file 'description' to name the repository.
================================================
FILE: .git/hooks/applypatch-msg.sample
================================================
#!/bin/sh
#
# An example hook script to check the commit log message taken by
# applypatch from an e-mail message.
#
# The hook should exit with non-zero status after issuing an
# appropriate message if it wants to stop the commit. The hook is
# allowed to edit the commit message file.
#
# To enable this hook, rename this file to "applypatch-msg".
. git-sh-setup
commitmsg="$(git rev-parse --git-path hooks/commit-msg)"
test -x "$commitmsg" && exec "$commitmsg" ${1+"$@"}
:
================================================
FILE: .git/hooks/commit-msg.sample
================================================
#!/bin/sh
#
# An example hook script to check the commit log message.
# Called by "git commit" with one argument, the name of the file
# that has the commit message. The hook should exit with non-zero
# status after issuing an appropriate message if it wants to stop the
# commit. The hook is allowed to edit the commit message file.
#
# To enable this hook, rename this file to "commit-msg".
# Uncomment the below to add a Signed-off-by line to the message.
# Doing this in a hook is a bad idea in general, but the prepare-commit-msg
# hook is more suited to it.
#
# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"
# This example catches duplicate Signed-off-by lines.
test "" = "$(grep '^Signed-off-by: ' "$1" |
sort | uniq -c | sed -e '/^[ ]*1[ ]/d')" || {
echo >&2 Duplicate Signed-off-by lines.
exit 1
}
================================================
FILE: .git/hooks/fsmonitor-watchman.sample
================================================
#!/usr/bin/perl
use strict;
use warnings;
use IPC::Open2;
# An example hook script to integrate Watchman
# (https://facebook.github.io/watchman/) with git to speed up detecting
# new and modified files.
#
# The hook is passed a version (currently 2) and last update token
# formatted as a string and outputs to stdout a new update token and
# all files that have been modified since the update token. Paths must
# be relative to the root of the working tree and separated by a single NUL.
#
# To enable this hook, rename this file to "query-watchman" and set
# 'git config core.fsmonitor .git/hooks/query-watchman'
#
my ($version, $last_update_token) = @ARGV;
# Uncomment for debugging
# print STDERR "$0 $version $last_update_token\n";
# Check the hook interface version
if ($version ne 2) {
die "Unsupported query-fsmonitor hook version '$version'.\n" .
"Falling back to scanning...\n";
}
my $git_work_tree = get_working_dir();
my $retry = 1;
my $json_pkg;
eval {
require JSON::XS;
$json_pkg = "JSON::XS";
1;
} or do {
require JSON::PP;
$json_pkg = "JSON::PP";
};
launch_watchman();
sub launch_watchman {
my $o = watchman_query();
if (is_work_tree_watched($o)) {
output_result($o->{clock}, @{$o->{files}});
}
}
sub output_result {
my ($clockid, @files) = @_;
# Uncomment for debugging watchman output
# open (my $fh, ">", ".git/watchman-output.out");
# binmode $fh, ":utf8";
# print $fh "$clockid\n@files\n";
# close $fh;
binmode STDOUT, ":utf8";
print $clockid;
print "\0";
local $, = "\0";
print @files;
}
sub watchman_clock {
my $response = qx/watchman clock "$git_work_tree"/;
die "Failed to get clock id on '$git_work_tree'.\n" .
"Falling back to scanning...\n" if $? != 0;
return $json_pkg->new->utf8->decode($response);
}
sub watchman_query {
my $pid = open2(\*CHLD_OUT, \*CHLD_IN, 'watchman -j --no-pretty')
or die "open2() failed: $!\n" .
"Falling back to scanning...\n";
# In the query expression below we're asking for names of files that
# changed since $last_update_token but not from the .git folder.
#
# To accomplish this, we're using the "since" generator to use the
# recency index to select candidate nodes and "fields" to limit the
# output to file names only. Then we're using the "expression" term to
# further constrain the results.
my $last_update_line = "";
if (substr($last_update_token, 0, 1) eq "c") {
$last_update_token = "\"$last_update_token\"";
$last_update_line = qq[\n"since": $last_update_token,];
}
my $query = <<" END";
["query", "$git_work_tree", {$last_update_line
"fields": ["name"],
"expression": ["not", ["dirname", ".git"]]
}]
END
# Uncomment for debugging the watchman query
# open (my $fh, ">", ".git/watchman-query.json");
# print $fh $query;
# close $fh;
print CHLD_IN $query;
close CHLD_IN;
my $response = do {local $/; <CHLD_OUT>};
# Uncomment for debugging the watch response
# open ($fh, ">", ".git/watchman-response.json");
# print $fh $response;
# close $fh;
die "Watchman: command returned no output.\n" .
"Falling back to scanning...\n" if $response eq "";
die "Watchman: command returned invalid output: $response\n" .
"Falling back to scanning...\n" unless $response =~ /^\{/;
return $json_pkg->new->utf8->decode($response);
}
sub is_work_tree_watched {
my ($output) = @_;
my $error = $output->{error};
if ($retry > 0 and $error and $error =~ m/unable to resolve root .* directory (.*) is not watched/) {
$retry--;
my $response = qx/watchman watch "$git_work_tree"/;
die "Failed to make watchman watch '$git_work_tree'.\n" .
"Falling back to scanning...\n" if $? != 0;
$output = $json_pkg->new->utf8->decode($response);
$error = $output->{error};
die "Watchman: $error.\n" .
"Falling back to scanning...\n" if $error;
# Uncomment for debugging watchman output
# open (my $fh, ">", ".git/watchman-output.out");
# close $fh;
# Watchman will always return all files on the first query so
# return the fast "everything is dirty" flag to git and do the
# Watchman query just to get it over with now so we won't pay
# the cost in git to look up each individual file.
my $o = watchman_clock();
$error = $output->{error};
die "Watchman: $error.\n" .
"Falling back to scanning...\n" if $error;
output_result($o->{clock}, ("/"));
$last_update_token = $o->{clock};
eval { launch_watchman() };
return 0;
}
die "Watchman: $error.\n" .
"Falling back to scanning...\n" if $error;
return 1;
}
sub get_working_dir {
my $working_dir;
if ($^O =~ 'msys' || $^O =~ 'cygwin') {
$working_dir = Win32::GetCwd();
$working_dir =~ tr/\\/\//;
} else {
require Cwd;
$working_dir = Cwd::cwd();
}
return $working_dir;
}
================================================
FILE: .git/hooks/post-update.sample
================================================
#!/bin/sh
#
# An example hook script to prepare a packed repository for use over
# dumb transports.
#
# To enable this hook, rename this file to "post-update".
exec git update-server-info
================================================
FILE: .git/hooks/pre-applypatch.sample
================================================
#!/bin/sh
#
# An example hook script to verify what is about to be committed
# by applypatch from an e-mail message.
#
# The hook should exit with non-zero status after issuing an
# appropriate message if it wants to stop the commit.
#
# To enable this hook, rename this file to "pre-applypatch".
. git-sh-setup
precommit="$(git rev-parse --git-path hooks/pre-commit)"
test -x "$precommit" && exec "$precommit" ${1+"$@"}
:
================================================
FILE: .git/hooks/pre-commit.sample
================================================
#!/bin/sh
#
# An example hook script to verify what is about to be committed.
# Called by "git commit" with no arguments. The hook should
# exit with non-zero status after issuing an appropriate message if
# it wants to stop the commit.
#
# To enable this hook, rename this file to "pre-commit".
if git rev-parse --verify HEAD >/dev/null 2>&1
then
against=HEAD
else
# Initial commit: diff against an empty tree object
against=$(git hash-object -t tree /dev/null)
fi
# If you want to allow non-ASCII filenames set this variable to true.
allownonascii=$(git config --type=bool hooks.allownonascii)
# Redirect output to stderr.
exec 1>&2
# Cross platform projects tend to avoid non-ASCII filenames; prevent
# them from being added to the repository. We exploit the fact that the
# printable range starts at the space character and ends with tilde.
if [ "$allownonascii" != "true" ] &&
# Note that the use of brackets around a tr range is ok here, (it's
# even required, for portability to Solaris 10's /usr/bin/tr), since
# the square bracket bytes happen to fall in the designated range.
test $(git diff-index --cached --name-only --diff-filter=A -z $against |
LC_ALL=C tr -d '[ -~]\0' | wc -c) != 0
then
cat <<\EOF
Error: Attempt to add a non-ASCII file name.
This can cause problems if you want to work with people on other platforms.
To be portable it is advisable to rename the file.
If you know what you are doing you can disable this check using:
git config hooks.allownonascii true
EOF
exit 1
fi
# If there are whitespace errors, print the offending file names and fail.
exec git diff-index --check --cached $against --
================================================
FILE: .git/hooks/pre-merge-commit.sample
================================================
#!/bin/sh
#
# An example hook script to verify what is about to be committed.
# Called by "git merge" with no arguments. The hook should
# exit with non-zero status after issuing an appropriate message to
# stderr if it wants to stop the merge commit.
#
# To enable this hook, rename this file to "pre-merge-commit".
. git-sh-setup
test -x "$GIT_DIR/hooks/pre-commit" &&
exec "$GIT_DIR/hooks/pre-commit"
:
================================================
FILE: .git/hooks/pre-push.sample
================================================
#!/bin/sh
# An example hook script to verify what is about to be pushed. Called by "git
# push" after it has checked the remote status, but before anything has been
# pushed. If this script exits with a non-zero status nothing will be pushed.
#
# This hook is called with the following parameters:
#
# $1 -- Name of the remote to which the push is being done
# $2 -- URL to which the push is being done
#
# If pushing without using a named remote those arguments will be equal.
#
# Information about the commits which are being pushed is supplied as lines to
# the standard input in the form:
#
# <local ref> <local oid> <remote ref> <remote oid>
#
# This sample shows how to prevent push of commits where the log message starts
# with "WIP" (work in progress).
remote="$1"
url="$2"
zero=$(git hash-object --stdin </dev/null | tr '[0-9a-f]' '0')
while read local_ref local_oid remote_ref remote_oid
do
if test "$local_oid" = "$zero"
then
# Handle delete
:
else
if test "$remote_oid" = "$zero"
then
# New branch, examine all commits
range="$local_oid"
else
# Update to existing branch, examine new commits
range="$remote_oid..$local_oid"
fi
# Check for WIP commit
commit=$(git rev-list -n 1 --grep '^WIP' "$range")
if test -n "$commit"
then
echo >&2 "Found WIP commit in $local_ref, not pushing"
exit 1
fi
fi
done
exit 0
================================================
FILE: .git/hooks/pre-rebase.sample
================================================
#!/bin/sh
#
# Copyright (c) 2006, 2008 Junio C Hamano
#
# The "pre-rebase" hook is run just before "git rebase" starts doing
# its job, and can prevent the command from running by exiting with
# non-zero status.
#
# The hook is called with the following parameters:
#
# $1 -- the upstream the series was forked from.
# $2 -- the branch being rebased (or empty when rebasing the current branch).
#
# This sample shows how to prevent topic branches that are already
# merged to 'next' branch from getting rebased, because allowing it
# would result in rebasing already published history.
publish=next
basebranch="$1"
if test "$#" = 2
then
topic="refs/heads/$2"
else
topic=`git symbolic-ref HEAD` ||
exit 0 ;# we do not interrupt rebasing detached HEAD
fi
case "$topic" in
refs/heads/??/*)
;;
*)
exit 0 ;# we do not interrupt others.
;;
esac
# Now we are dealing with a topic branch being rebased
# on top of master. Is it OK to rebase it?
# Does the topic really exist?
git show-ref -q "$topic" || {
echo >&2 "No such branch $topic"
exit 1
}
# Is topic fully merged to master?
not_in_master=`git rev-list --pretty=oneline ^master "$topic"`
if test -z "$not_in_master"
then
echo >&2 "$topic is fully merged to master; better remove it."
exit 1 ;# we could allow it, but there is no point.
fi
# Is topic ever merged to next? If so you should not be rebasing it.
only_next_1=`git rev-list ^master "^$topic" ${publish} | sort`
only_next_2=`git rev-list ^master ${publish} | sort`
if test "$only_next_1" = "$only_next_2"
then
not_in_topic=`git rev-list "^$topic" master`
if test -z "$not_in_topic"
then
echo >&2 "$topic is already up to date with master"
exit 1 ;# we could allow it, but there is no point.
else
exit 0
fi
else
not_in_next=`git rev-list --pretty=oneline ^${publish} "$topic"`
/usr/bin/perl -e '
my $topic = $ARGV[0];
my $msg = "* $topic has commits already merged to public branch:\n";
my (%not_in_next) = map {
/^([0-9a-f]+) /;
($1 => 1);
} split(/\n/, $ARGV[1]);
for my $elem (map {
/^([0-9a-f]+) (.*)$/;
[$1 => $2];
} split(/\n/, $ARGV[2])) {
if (!exists $not_in_next{$elem->[0]}) {
if ($msg) {
print STDERR $msg;
undef $msg;
}
print STDERR " $elem->[1]\n";
}
}
' "$topic" "$not_in_next" "$not_in_master"
exit 1
fi
<<\DOC_END
This sample hook safeguards topic branches that have been
published from being rewound.
The workflow assumed here is:
* Once a topic branch forks from "master", "master" is never
merged into it again (either directly or indirectly).
* Once a topic branch is fully cooked and merged into "master",
it is deleted. If you need to build on top of it to correct
earlier mistakes, a new topic branch is created by forking at
the tip of the "master". This is not strictly necessary, but
it makes it easier to keep your history simple.
* Whenever you need to test or publish your changes to topic
branches, merge them into "next" branch.
The script, being an example, hardcodes the publish branch name
to be "next", but it is trivial to make it configurable via
$GIT_DIR/config mechanism.
With this workflow, you would want to know:
(1) ... if a topic branch has ever been merged to "next". Young
topic branches can have stupid mistakes you would rather
clean up before publishing, and things that have not been
merged into other branches can be easily rebased without
affecting other people. But once it is published, you would
not want to rewind it.
(2) ... if a topic branch has been fully merged to "master".
Then you can delete it. More importantly, you should not
build on top of it -- other people may already want to
change things related to the topic as patches against your
"master", so if you need further changes, it is better to
fork the topic (perhaps with the same name) afresh from the
tip of "master".
Let's look at this example:
o---o---o---o---o---o---o---o---o---o "next"
/ / / /
/ a---a---b A / /
/ / / /
/ / c---c---c---c B /
/ / / \ /
/ / / b---b C \ /
/ / / / \ /
---o---o---o---o---o---o---o---o---o---o---o "master"
A, B and C are topic branches.
* A has one fix since it was merged up to "next".
* B has finished. It has been fully merged up to "master" and "next",
and is ready to be deleted.
* C has not merged to "next" at all.
We would want to allow C to be rebased, refuse A, and encourage
B to be deleted.
To compute (1):
git rev-list ^master ^topic next
git rev-list ^master next
if these match, topic has not merged in next at all.
To compute (2):
git rev-list master..topic
if this is empty, it is fully merged to "master".
DOC_END
================================================
FILE: .git/hooks/pre-receive.sample
================================================
#!/bin/sh
#
# An example hook script to make use of push options.
# The example simply echoes all push options that start with 'echoback='
# and rejects all pushes when the "reject" push option is used.
#
# To enable this hook, rename this file to "pre-receive".
if test -n "$GIT_PUSH_OPTION_COUNT"
then
i=0
while test "$i" -lt "$GIT_PUSH_OPTION_COUNT"
do
eval "value=\$GIT_PUSH_OPTION_$i"
case "$value" in
echoback=*)
echo "echo from the pre-receive-hook: ${value#*=}" >&2
;;
reject)
exit 1
esac
i=$((i + 1))
done
fi
================================================
FILE: .git/hooks/prepare-commit-msg.sample
================================================
#!/bin/sh
#
# An example hook script to prepare the commit log message.
# Called by "git commit" with the name of the file that has the
# commit message, followed by the description of the commit
# message's source. The hook's purpose is to edit the commit
# message file. If the hook fails with a non-zero status,
# the commit is aborted.
#
# To enable this hook, rename this file to "prepare-commit-msg".
# This hook includes three examples. The first one removes the
# "# Please enter the commit message..." help message.
#
# The second includes the output of "git diff --name-status -r"
# into the message, just before the "git status" output. It is
# commented because it doesn't cope with --amend or with squashed
# commits.
#
# The third example adds a Signed-off-by line to the message, that can
# still be edited. This is rarely a good idea.
COMMIT_MSG_FILE=$1
COMMIT_SOURCE=$2
SHA1=$3
/usr/bin/perl -i.bak -ne 'print unless(m/^. Please enter the commit message/..m/^#$/)' "$COMMIT_MSG_FILE"
# case "$COMMIT_SOURCE,$SHA1" in
# ,|template,)
# /usr/bin/perl -i.bak -pe '
# print "\n" . `git diff --cached --name-status -r`
# if /^#/ && $first++ == 0' "$COMMIT_MSG_FILE" ;;
# *) ;;
# esac
# SOB=$(git var GIT_COMMITTER_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
# git interpret-trailers --in-place --trailer "$SOB" "$COMMIT_MSG_FILE"
# if test -z "$COMMIT_SOURCE"
# then
# /usr/bin/perl -i.bak -pe 'print "\n" if !$first_line++' "$COMMIT_MSG_FILE"
# fi
================================================
FILE: .git/hooks/push-to-checkout.sample
================================================
#!/bin/sh
# An example hook script to update a checked-out tree on a git push.
#
# This hook is invoked by git-receive-pack(1) when it reacts to git
# push and updates reference(s) in its repository, and when the push
# tries to update the branch that is currently checked out and the
# receive.denyCurrentBranch configuration variable is set to
# updateInstead.
#
# By default, such a push is refused if the working tree and the index
# of the remote repository has any difference from the currently
# checked out commit; when both the working tree and the index match
# the current commit, they are updated to match the newly pushed tip
# of the branch. This hook is to be used to override the default
# behaviour; however the code below reimplements the default behaviour
# as a starting point for convenient modification.
#
# The hook receives the commit with which the tip of the current
# branch is going to be updated:
commit=$1
# It can exit with a non-zero status to refuse the push (when it does
# so, it must not modify the index or the working tree).
die () {
echo >&2 "$*"
exit 1
}
# Or it can make any necessary changes to the working tree and to the
# index to bring them to the desired state when the tip of the current
# branch is updated to the new commit, and exit with a zero status.
#
# For example, the hook can simply run git read-tree -u -m HEAD "$1"
# in order to emulate git fetch that is run in the reverse direction
# with git push, as the two-tree form of git read-tree -u -m is
# essentially the same as git switch or git checkout that switches
# branches while keeping the local changes in the working tree that do
# not interfere with the difference between the branches.
# The below is a more-or-less exact translation to shell of the C code
# for the default behaviour for git's push-to-checkout hook defined in
# the push_to_deploy() function in builtin/receive-pack.c.
#
# Note that the hook will be executed from the repository directory,
# not from the working tree, so if you want to perform operations on
# the working tree, you will have to adapt your code accordingly, e.g.
# by adding "cd .." or using relative paths.
if ! git update-index -q --ignore-submodules --refresh
then
die "Up-to-date check failed"
fi
if ! git diff-files --quiet --ignore-submodules --
then
die "Working directory has unstaged changes"
fi
# This is a rough translation of:
#
# head_has_history() ? "HEAD" : EMPTY_TREE_SHA1_HEX
if git cat-file -e HEAD 2>/dev/null
then
head=HEAD
else
head=$(git hash-object -t tree --stdin </dev/null)
fi
if ! git diff-index --quiet --cached --ignore-submodules $head --
then
die "Working directory has staged changes"
fi
if ! git read-tree -u -m "$commit"
then
die "Could not update working tree to new HEAD"
fi
================================================
FILE: .git/hooks/sendemail-validate.sample
================================================
#!/bin/sh
# An example hook script to validate a patch (and/or patch series) before
# sending it via email.
#
# The hook should exit with non-zero status after issuing an appropriate
# message if it wants to prevent the email(s) from being sent.
#
# To enable this hook, rename this file to "sendemail-validate".
#
# By default, it will only check that the patch(es) can be applied on top of
# the default upstream branch without conflicts in a secondary worktree. After
# validation (successful or not) of the last patch of a series, the worktree
# will be deleted.
#
# The following config variables can be set to change the default remote and
# remote ref that are used to apply the patches against:
#
# sendemail.validateRemote (default: origin)
# sendemail.validateRemoteRef (default: HEAD)
#
# Replace the TODO placeholders with appropriate checks according to your
# needs.
validate_cover_letter () {
file="$1"
# TODO: Replace with appropriate checks (e.g. spell checking).
true
}
validate_patch () {
file="$1"
# Ensure that the patch applies without conflicts.
git am -3 "$file" || return
# TODO: Replace with appropriate checks for this patch
# (e.g. checkpatch.pl).
true
}
validate_series () {
# TODO: Replace with appropriate checks for the whole series
# (e.g. quick build, coding style checks, etc.).
true
}
# main -------------------------------------------------------------------------
if test "$GIT_SENDEMAIL_FILE_COUNTER" = 1
then
remote=$(git config --default origin --get sendemail.validateRemote) &&
ref=$(git config --default HEAD --get sendemail.validateRemoteRef) &&
worktree=$(mktemp --tmpdir -d sendemail-validate.XXXXXXX) &&
git worktree add -fd --checkout "$worktree" "refs/remotes/$remote/$ref" &&
git config --replace-all sendemail.validateWorktree "$worktree"
else
worktree=$(git config --get sendemail.validateWorktree)
fi || {
echo "sendemail-validate: error: failed to prepare worktree" >&2
exit 1
}
unset GIT_DIR GIT_WORK_TREE
cd "$worktree" &&
if grep -q "^diff --git " "$1"
then
validate_patch "$1"
else
validate_cover_letter "$1"
fi &&
if test "$GIT_SENDEMAIL_FILE_COUNTER" = "$GIT_SENDEMAIL_FILE_TOTAL"
then
git config --unset-all sendemail.validateWorktree &&
trap 'git worktree remove -ff "$worktree"' EXIT &&
validate_series
fi
================================================
FILE: .git/hooks/update.sample
================================================
#!/bin/sh
#
# An example hook script to block unannotated tags from entering.
# Called by "git receive-pack" with arguments: refname sha1-old sha1-new
#
# To enable this hook, rename this file to "update".
#
# Config
# ------
# hooks.allowunannotated
# This boolean sets whether unannotated tags will be allowed into the
# repository. By default they won't be.
# hooks.allowdeletetag
# This boolean sets whether deleting tags will be allowed in the
# repository. By default they won't be.
# hooks.allowmodifytag
# This boolean sets whether a tag may be modified after creation. By default
# it won't be.
# hooks.allowdeletebranch
# This boolean sets whether deleting branches will be allowed in the
# repository. By default they won't be.
# hooks.denycreatebranch
# This boolean sets whether remotely creating branches will be denied
# in the repository. By default this is allowed.
#
# --- Command line
refname="$1"
oldrev="$2"
newrev="$3"
# --- Safety check
if [ -z "$GIT_DIR" ]; then
echo "Don't run this script from the command line." >&2
echo " (if you want, you could supply GIT_DIR then run" >&2
echo " $0 <ref> <oldrev> <newrev>)" >&2
exit 1
fi
if [ -z "$refname" -o -z "$oldrev" -o -z "$newrev" ]; then
echo "usage: $0 <ref> <oldrev> <newrev>" >&2
exit 1
fi
# --- Config
allowunannotated=$(git config --type=bool hooks.allowunannotated)
allowdeletebranch=$(git config --type=bool hooks.allowdeletebranch)
denycreatebranch=$(git config --type=bool hooks.denycreatebranch)
allowdeletetag=$(git config --type=bool hooks.allowdeletetag)
allowmodifytag=$(git config --type=bool hooks.allowmodifytag)
# check for no description
projectdesc=$(sed -e '1q' "$GIT_DIR/description")
case "$projectdesc" in
"Unnamed repository"* | "")
echo "*** Project description file hasn't been set" >&2
exit 1
;;
esac
# --- Check types
# if $newrev is 0000...0000, it's a commit to delete a ref.
zero=$(git hash-object --stdin </dev/null | tr '[0-9a-f]' '0')
if [ "$newrev" = "$zero" ]; then
newrev_type=delete
else
newrev_type=$(git cat-file -t $newrev)
fi
case "$refname","$newrev_type" in
refs/tags/*,commit)
# un-annotated tag
short_refname=${refname##refs/tags/}
if [ "$allowunannotated" != "true" ]; then
echo "*** The un-annotated tag, $short_refname, is not allowed in this repository" >&2
echo "*** Use 'git tag [ -a | -s ]' for tags you want to propagate." >&2
exit 1
fi
;;
refs/tags/*,delete)
# delete tag
if [ "$allowdeletetag" != "true" ]; then
echo "*** Deleting a tag is not allowed in this repository" >&2
exit 1
fi
;;
refs/tags/*,tag)
# annotated tag
if [ "$allowmodifytag" != "true" ] && git rev-parse $refname > /dev/null 2>&1
then
echo "*** Tag '$refname' already exists." >&2
echo "*** Modifying a tag is not allowed in this repository." >&2
exit 1
fi
;;
refs/heads/*,commit)
# branch
if [ "$oldrev" = "$zero" -a "$denycreatebranch" = "true" ]; then
echo "*** Creating a branch is not allowed in this repository" >&2
exit 1
fi
;;
refs/heads/*,delete)
# delete branch
if [ "$allowdeletebranch" != "true" ]; then
echo "*** Deleting a branch is not allowed in this repository" >&2
exit 1
fi
;;
refs/remotes/*,commit)
# tracking branch
;;
refs/remotes/*,delete)
# delete tracking branch
if [ "$allowdeletebranch" != "true" ]; then
echo "*** Deleting a tracking branch is not allowed in this repository" >&2
exit 1
fi
;;
*)
# Anything else (is there anything else?)
echo "*** Update hook: unknown type of update to ref $refname of type $newrev_type" >&2
exit 1
;;
esac
# --- Finished
exit 0
================================================
FILE: .git/info/exclude
================================================
# git ls-files --others --exclude-from=.git/info/exclude
# Lines that start with '#' are comments.
# For a project mostly in C, the following would be a good set of
# exclude patterns (uncomment them if you want to use them):
# *.[oa]
# *~
================================================
FILE: .git/logs/HEAD
================================================
0000000000000000000000000000000000000000 8eac94dbe90ea432453ea42168bf116af5d4ed8f appuser <appuser@7c99e0e64a07.(none)> 1777706829 +0000 clone: from https://github.com/endurox-dev/endurox
================================================
FILE: .git/logs/refs/heads/master
================================================
0000000000000000000000000000000000000000 8eac94dbe90ea432453ea42168bf116af5d4ed8f appuser <appuser@7c99e0e64a07.(none)> 1777706829 +0000 clone: from https://github.com/endurox-dev/endurox
================================================
FILE: .git/logs/refs/remotes/origin/HEAD
================================================
0000000000000000000000000000000000000000 8eac94dbe90ea432453ea42168bf116af5d4ed8f appuser <appuser@7c99e0e64a07.(none)> 1777706829 +0000 clone: from https://github.com/endurox-dev/endurox
================================================
FILE: .git/objects/pack/pack-ac0e6b253efd0968978b6cfa07966fb2fd6c8472.promisor
================================================
8eac94dbe90ea432453ea42168bf116af5d4ed8f refs/heads/master
================================================
FILE: .git/objects/pack/pack-b7dd7c6b8faf35a4d673846f8e7cf364a2d6e697.promisor
================================================
================================================
FILE: .git/packed-refs
================================================
# pack-refs with: peeled fully-peeled sorted
8eac94dbe90ea432453ea42168bf116af5d4ed8f refs/remotes/origin/master
================================================
FILE: .git/refs/heads/master
================================================
8eac94dbe90ea432453ea42168bf116af5d4ed8f
================================================
FILE: .git/refs/remotes/origin/HEAD
================================================
ref: refs/remotes/origin/master
================================================
FILE: .git/shallow
================================================
8eac94dbe90ea432453ea42168bf116af5d4ed8f
================================================
FILE: .gitignore
================================================
# Ignore all
*
# Unignore all with extensions
!*.*
# Unignore all dirs
!*/
install_manifest.txt
nbproject
include/ndrx_config.h
sampleconfig/*
*.log
*.pdf
CMakeFiles
*.cmake
*.so
*.out
libubf/expr.lex.c
libubf/expr.tab.c
libubf/expr.tab.h
Makefile
*.a
CMakeCache.txt
*.html
!pscript.html
!psstdlib.html
*.css
*.sv*
atmitest/test028_tmq/q.conf
atmitest/test006_ulog/log
*.png
!exforward_forward.png
!exforward_tpcall.png
!rt-patching.png
!server_monitoring_and_recovery.png
!tmqinternals.png
atmitest/test029_inicfg/C_test.ini
*.dylib
*.8
*.5
*.3
libatmisrv/atmisrvinteg.pc
atmitest/test040_typedview/t40.V
atmitest/test040_typedview/t40.h
atmitest/test040_typedview/t40_2.V
atmitest/test040_typedview/t40_2.h
libpsstdlib/WizardBase.c
xadmin/Exfields.c
xadmin/gen_c_client.c
xadmin/gen_c_server.c
xadmin/gen_go_client.c
xadmin/gen_go_server.c
xadmin/gen_ubf_tab.c
xadmin/provision.c
/dist/
atmitest/test056_tpimpexp/t56.V
atmitest/test056_tpimpexp/t56.h
xadmin/gen_test_local.c
xadmin/ndrx_config.c
libextest/test_view.h
libextest/test_view.V
xadmin/gen_java_client.c
xadmin/gen_java_server.c
xadmin/gen_python_client.c
xadmin/gen_python_server.c
ubftest/ULOG.*
ndrxd/expr_range.lex.c
ndrxd/expr_range.tab.c
ndrxd/expr_range.tab.h
migration/tuxedo/ddr.lex.c
migration/tuxedo/ddr.tab.c
migration/tuxedo/ddr.tab.h
migration/tuxedo/ubb.lex.c
migration/tuxedo/ubb.tab.c
migration/tuxedo/ubb.tab.h
migration/tuxedo/ubb2ex_bytecode.c
build/compile_commands.json
build/doc/tmqinternals.png
build/include/ndrx_config.h
build/libatmisrv/atmisrvinteg.pc
build/libubf/expr.lex.c
build/libubf/expr.tab.c
build/libubf/expr.tab.h
atmitest/*/ULOG.*
atmitest/test031_logging/logs_cfg/*
atmitest/test033_provision/runtime/*
atmitest/test043_encrypt/test.conf
atmitest/test046_twopasscfg/app.ini
atmitest/test048_cache/*/*.edb
atmitest/test048_cache/*/*/*.edb
atmitest/test050_ubfdb/db/*.edb
atmitest/test077_diedslowstrt/first-indicator.txt
atmitest/test083_ddrsyntax/ndrxconfig-dom1.xml
atmitest/test084_ddr/ndrxconfig-dom1.xml
atmitest/test087_tmsrv/lib1.rets
atmitest/test087_tmsrv/lib2.rets
atmitest/test090_tuxmig/env_common.txt
.vscode/*
================================================
FILE: CMakeLists.txt
================================================
##
## @brief Enduro Execution platform main Make descriptor
##
## @file CMakeLists.txt
##
## -----------------------------------------------------------------------------
## Enduro/X Middleware Platform for Distributed Transaction Processing
## Copyright (C) 2009-2016, ATR Baltic, Ltd. All Rights Reserved.
## Copyright (C) 2017-2023, Mavimax, Ltd. All Rights Reserved.
## This software is released under one of the following licenses:
## AGPL (with Java and Go exceptions) or Mavimax's license for commercial use.
## See LICENSE file for full text.
## -----------------------------------------------------------------------------
## AGPL license:
##
## This program is free software; you can redistribute it and/or modify it under
## the terms of the GNU Affero General Public License, version 3 as published
## by the Free Software Foundation;
##
## This program is distributed in the hope that it will be useful, but WITHOUT ANY
## WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
## PARTICULAR PURPOSE. See the GNU Affero General Public License, version 3
## for more details.
##
## You should have received a copy of the GNU Affero General Public License along
## with this program; if not, write to the Free Software Foundation, Inc.,
## 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
## -----------------------------------------------------------------------------
## A commercial use license is available from Mavimax, Ltd
## contact@mavimax.com
## -----------------------------------------------------------------------------
##
cmake_minimum_required (VERSION 3.5)
project (ENDUROX)
include(cmake/ex_osver.cmake)
include(cmake/ex_comp.cmake)
set(VERSION "8.0.12")
set(PROJ_NAME "Enduro/X")
set(RELEASE "1")
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
string(REPLACE "." ";" VERSION_LIST ${VERSION})
list(GET VERSION_LIST 0 NDRX_VERSION_MAJOR)
list(GET VERSION_LIST 1 NDRX_VERSION_MINOR)
list(GET VERSION_LIST 2 NDRX_VERSION_PATCH)
MATH (EXPR NDRX_VERSION_NUM "${NDRX_VERSION_MAJOR} * 10000 + ${NDRX_VERSION_MINOR} * 100 + ${NDRX_VERSION_PATCH}")
################################################################################
# Check versions if defined, export build env
################################################################################
if(DEFINED ENV{NDRX_BLD_VERSION})
IF(NOT ENV{NDRX_BLD_VERSION} MATCHES VERSION)
message( FATAL_ERROR "Invalid versions: ENV: [$ENV{NDRX_BLD_VERSION}] Code: [${VERSION}]" )
endif()
endif()
if(DEFINED ENV{NDRX_BLD_RELEASE})
set(RELEASE $ENV{NDRX_BLD_RELEASE})
endif()
message("CMake RELEASE = ${RELEASE}")
SET (NDRX_BLD_PRODUCT $ENV{NDRX_BLD_PRODUCT})
SET (NDRX_BLD_SYSTEM $ENV{NDRX_BLD_SYSTEM})
SET (NDRX_BLD_CONFIG $ENV{NDRX_BLD_CONFIG})
SET (NDRX_BLD_VERSION $ENV{NDRX_BLD_VERSION})
SET (NDRX_BLD_RELEASE $ENV{NDRX_BLD_RELEASE})
SET (NDRX_BLD_TAG $ENV{NDRX_BLD_TAG})
SET (NDRX_BLD_BRANCH $ENV{NDRX_BLD_BRANCH})
SET (NDRX_BLD_COMMIT $ENV{NDRX_BLD_COMMIT})
SET (NDRX_BLD_FLAGS $ENV{NDRX_BLD_FLAGS})
#
# Get the git version (the version which is
#
execute_process(
COMMAND
git rev-parse HEAD
RESULT_VARIABLE
gitres
OUTPUT_VARIABLE
NDRX_BLD_HASH
)
string(REGEX REPLACE "\n$" "" NDRX_BLD_HASH "${NDRX_BLD_HASH}")
if (NOT gitres EQUAL 0)
SET (NDRX_BLD_HASH "unknown")
endif ()
################################################################################
# OS Configuration
################################################################################
# configure compiler
ex_comp_settings()
# Enable oracle test to run
IF (ENABLE_TEST47)
set(NDRX_ENABLE_TEST47 "1")
ENDIF()
IF(EX_USE_SYSVQ)
set(EX_POLLER_STR "SystemV")
ELSEIF(EX_USE_FDPOLL)
set(EX_POLLER_STR "fdpoll")
ELSEIF(EX_USE_EMQ)
set(EX_POLLER_STR "emq")
ELSEIF(EX_USE_POLL)
set(EX_POLLER_STR "poll")
ELSEIF(EX_USE_EPOLL)
set(EX_POLLER_STR "epoll")
ELSEIF(EX_USE_KQUEUE)
set(EX_POLLER_STR "kqueue")
ELSEIF(EX_USE_SVAPOLL)
set(EX_POLLER_STR "svapoll")
ELSE()
message( FATAL_ERROR "ERROR! Invalid queue transport backend!" )
ENDIF()
message("CMake EX_ALIGNMENT_BYTES = ${EX_ALIGNMENT_BYTES}")
message("Poller = ${EX_POLLER_STR}")
message("ALIGNMENT_FORCE = ${EX_ALIGNMENT_FORCE}")
################################################################################
# "Configure"
################################################################################
# In this file we are doing all of our 'configure' checks. Things like checking
# for headers, functions, libraries, types and size of types.
# Includes from osver package
ex_osver_include()
INCLUDE (${CMAKE_ROOT}/Modules/CheckIncludeFile.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/CheckFunctionExists.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/CheckCSourceCompiles.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/CheckCXXSourceCompiles.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/TestBigEndian.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/CheckSymbolExists.cmake)
CHECK_C_SOURCE_COMPILES("int main() {__builtin_expect(1, 1);}" HAVE_EXPECT)
CHECK_CXX_SOURCE_COMPILES("int main() {__builtin_expect(1, 1);}" HAVE_EXPECT_CXX)
CHECK_C_SOURCE_COMPILES("int main() { int X = 0; __sync_bool_compare_and_swap(&X, 0, 1); __sync_synchronize();}" HAVE_SYNC)
CHECK_C_SOURCE_COMPILES("#include <stdio.h> \n int main() {char buf[128]; size_t len; getline(buf, &len, stdin);}" HAVE_GETLINE)
CHECK_C_SOURCE_COMPILES("#include <sys/sem.h> \n int main(int argc, char **argv) {union semun u; return 0;}" EX_HAVE_SEMUN)
if(CMAKE_OS_NAME STREQUAL "AIX")
# it compiles OK, but we have no header where it is defined
# thus we get lots of warnings
message("No strlcpy/strcat_s/asprintf/__progname test for AIX")
set(HAVE_STRLCPY "0")
set(EX_HAVE_STRCAT_S "0")
else()
CHECK_C_SOURCE_COMPILES("#include <string.h> \n int main() {char dest[1]; char src[1]; strlcpy(dest, src, 1);}" HAVE_STRLCPY)
CHECK_C_SOURCE_COMPILES("#include <string.h> \n int main() {char tmp[8]={0x0}; strcat_s(tmp, sizeof(tmp), \"abc\");}" EX_HAVE_STRCAT_S)
CHECK_C_SOURCE_COMPILES("#include <string.h> \n int main() {char *tmp; asprintf(&tmp, \"HELLO\");}" EX_HAVE_ASPRINTF)
CHECK_C_SOURCE_COMPILES("extern const char * __progname; int main() {return __progname[0];}" HAVE_PROGNAME)
endif()
CHECK_C_SOURCE_COMPILES("#include <string.h> \n int main() {strnlen(\"ABC\", 1);}" HAVE_STRNLEN)
CHECK_C_SOURCE_COMPILES("#include <stdatomic.h> \n int main() {int i=0; atomic_fetch_add( &i, 1 );}" EX_HAVE_STDATOMIC)
CHECK_C_SOURCE_COMPILES("int main() {int i=0; __sync_fetch_and_add( &i, 1 );}" EX_HAVE_SYNCFETCHADD)
CHECK_C_SOURCE_COMPILES("#include <fcntl.h> \n int main() {posix_fadvise(0, 0, 0, POSIX_FADV_DONTNEED);}" EX_HAVE_POSIX_FADVISE)
# To check for an include file you do this:
CHECK_INCLUDE_FILE("stdint.h" HAVE_STDINT_H)
CHECK_INCLUDE_FILE("getopt.h" HAVE_GETOPT_H)
# To check the size of a primitive type:
CHECK_TYPE_SIZE("int" EX_SIZEOF_INT)
CHECK_TYPE_SIZE("long" EX_SIZEOF_LONG)
CHECK_TYPE_SIZE("void*" EX_SIZEOF_VOIDPTR)
MATH (EXPR EX_PLATFORM_BITS "${EX_SIZEOF_VOIDPTR} * 8")
IF (DEFINE_DISABLEPSCRIPT)
set(NDRX_DISABLEPSCRIPT "1")
ENDIF()
IF (DEFINE_SANITIZE)
set(NDRX_SANITIZE "1")
ENDIF()
IF (MUTEX_DEBUG)
set(NDRX_MUTEX_DEBUG "1")
ENDIF()
IF (ENABLE_POSTGRES)
set(NDRX_USE_POSTGRES "1")
ENDIF()
# Output the project version
set(NDRX_VERSION_STR "${PROJ_NAME} ${VERSION}")
# avoid configure warnings of not being used
# as they are used.
set(ignoreWarning "${DISABLE_ECPG} ${PostgreSQL_TYPE_INCLUDE_DIR}")
################################################################################
# Install dir config
################################################################################
get_property(LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
message("LIB: ${LIB64}")
if(CMAKE_OS_NAME STREQUAL "DARWIN")
set(LIB_SUFFIX "")
# Seems like BSD does not use lib64 folder
elseif (CMAKE_OS_NAME STREQUAL "FREEBSD")
set(LIB_SUFFIX "")
elseif (CMAKE_OS_NAME STREQUAL "AIX")
set(LIB_SUFFIX "")
elseif (LIB64 STREQUAL "TRUE")
set(LIB_SUFFIX 64)
else()
set(LIB_SUFFIX "")
endif()
message("LIB_SUFFIX: ${LIB_SUFFIX}")
set(INSTALL_LIB_DIR lib${LIB_SUFFIX} CACHE PATH "Installation directory for libraries")
message("INSTALL_LIB_DIR: ${INSTALL_LIB_DIR}")
mark_as_advanced(INSTALL_LIB_DIR)
MESSAGE( STATUS "INSTALL_LIB_DIR: " ${INSTALL_LIB_DIR} )
################################################################################
# Options
################################################################################
OPTION(DEFINE_DISABLEGPGME "Use GPG-ME encryption (not used, for compatiblity)" OFF)
OPTION(DEFINE_DISABLEPSCRIPT "Disable Platform Script" OFF)
###############################################################################
################################################################################
# Option to disable documentation build (dos are enabled by default)
if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
# not working on mac by default...
OPTION(DEFINE_DISABLEDOC "Disable documentation generation" ON)
else()
OPTION(DEFINE_DISABLEDOC "Disable documentation generation" OFF)
endif()
################################################################################
################################################################################
# Submakes
################################################################################
# Recurse into the project subdirectories. This does not actually
# cause another cmake executable to run. The same process will walk through
# the project's entire directory structure.
add_subdirectory (libnstd)
add_subdirectory (embedfile)
add_subdirectory (libcgreen)
add_subdirectory (libubf)
add_subdirectory (libnetproto)
add_subdirectory (mkfldhdr)
# Enduro/X sub-directories for ATMI
add_subdirectory (libatmi) # General Purpose ATMI library
add_subdirectory (libatmisrv) # ATMI server library
add_subdirectory (libatmiclt) # ATMI client library
add_subdirectory (libtux) # Tux lib emulation
add_subdirectory (libexnet)
add_subdirectory (libexmemck)
add_subdirectory (libndrxconf)
IF (NOT DEFINE_DISABLEPSCRIPT)
add_subdirectory (libps) # Platform script
add_subdirectory (libpsstdlib) # Platform script standard library
ENDIF()
add_subdirectory (tpevsrv)
add_subdirectory (tpcachesv)
add_subdirectory (tpcached)
add_subdirectory (tprecover) # Special recovery server
add_subdirectory (tpbrdcstsv) # tpbroadcast remote machine dispatcher
add_subdirectory (ud)
IF (NOT DEFINE_DISABLEPSCRIPT)
add_subdirectory (pscript) # Platform script interpreter
ENDIF()
add_subdirectory (viewc) # View compiler
add_subdirectory (ndrxd) # Enduro X daemon
add_subdirectory (tpadmsv) # Enduro/X Admin API Server
add_subdirectory (exsinglesv) # Enduro/X Singleton Lock provider
add_subdirectory (migration) # Migration tools
add_subdirectory (xadmin) # Enduro X command line interface
add_subdirectory (buildtools) # buildserver,buildclient,buildtms
add_subdirectory (lmdb_util) # LMDB/EXDB Admin utilities
add_subdirectory (xmemck) # Enduro X memcory checking tool
add_subdirectory (bridge) # Cluster bridge server
add_subdirectory (tmsrv) # Transaction Manager server for XA transactions
add_subdirectory (tmqueue) # Persistant Queue server
add_subdirectory (cpmsrv) # Client Process Monitor
add_subdirectory (xadrv) # XA Drivers for RMs
add_subdirectory (cconfsrv) # Common-Config server
add_subdirectory (exbench) # Enduro/X benchmark tools
add_subdirectory (plugins) # XA Drivers for RMs
add_subdirectory (enctools) # XA Drivers for RMs
add_subdirectory (libextest) # Shared test resource library
add_subdirectory (ubftest) # UBF library testing
add_subdirectory (atmitest) # ATMI testing
IF(DEFINE_DISABLEDOC)
message("Documentation disabled - not building")
ELSE (DEFINE_DISABLEDOC)
add_subdirectory (doc) # Documentation project.
ENDIF (DEFINE_DISABLEDOC)
add_subdirectory (include) # For install
add_subdirectory (scripts) # For install
add_subdirectory (cmake) # For install
#
# Install license files
#
install (FILES
LICENSE
DESTINATION share/endurox)
#
# Install third party licenses
#
install (FILES
doc/third_party_licences.adoc
DESTINATION share/endurox
RENAME THIRD_PARTY_LICENCES)
#
# Install stock RM file
#
install (FILES
scripts/RM
DESTINATION udataobj)
################################################################################
# uninstall target
################################################################################
configure_file(
"${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
IMMEDIATE @ONLY)
add_custom_target(uninstall
COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
################################################################################
# Packages
################################################################################
# Resolve OS versions...
ex_osver()
# Support only for Linux
MESSAGE( "CPack:Debug: CMAKE_SYSTEM_NAME = " ${CMAKE_SYSTEM_NAME} )
MESSAGE( "CPack:Debug: CMAKE_SYSTEM_PROCESSOR = " ${CMAKE_SYSTEM_PROCESSOR} )
set(CPACK_MONOLITHIC_INSTALL 1)
#
# Generate configuration
#
configure_file ("${PROJECT_SOURCE_DIR}/include/ndrx_config.h.in"
"${PROJECT_BINARY_DIR}/include/ndrx_config.h" )
# Test the available generators and then configure output
find_program(RPMPROG "rpmbuild")
find_program(APTPROG "dpkg")
# avoid file /usr/share/man from install of endurox-3.5.1-1.x86_64 conflicts with file from package filesystem-3.2-21.el7.x86_64
# problems...
set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/man
/usr/share/man/man3
/usr/share/man/man5
/usr/share/man/man8
/usr/lib64/pkgconfig
/usr/lib/pkgconfig)
message("Excl: ${CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION}")
set(CPACK_GENERATOR "TGZ")
if(RPMPROG)
message("Outputting RPM")
set(CPACK_GENERATOR "${CPACK_GENERATOR};RPM")
endif()
if(APTPROG)
message("Outputting DEB")
set(CPACK_GENERATOR "${CPACK_GENERATOR};DEB")
endif()
ex_cpuarch()
set(CPACK_PACKAGE_CONTACT "contact@mavimax.com")
set(CPACK_PACKAGE_VERSION ${VERSION})
set(CPACK_PACKAGE_VENDOR "Mavimax Ltd")
set(CPACK_RPM_PACKAGE_RELEASE ${RELEASE})
set(CPACK_RPM_PACKAGE_RELEASE_DIST ${RELEASE})
set(CPACK_DEBIAN_PACKAGE_RELEASE ${RELEASE})
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LO)
message("CPack:Debug: PROJECT NAME = ${PROJECT_NAME_LO}")
set(CPACK_PACKAGE_FILE_NAME ${PROJECT_NAME_LO}-${VERSION}-${RELEASE}.${LSB_RELEASE_OUTPUT_OS}${LSB_RELEASE_OUTPUT_VER}_${CMAKE_C_COMPILER_ID}_${EX_POLLER_STR}.${EX_CPU_ARCH})
string(TOLOWER ${CPACK_PACKAGE_FILE_NAME} CPACK_PACKAGE_FILE_NAME)
message("CPack:Debug: CPACK_PACKAGE_FILE_NAME = ${CPACK_PACKAGE_FILE_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Enduro/X Middleware Platform")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${CPACK_PACKAGE_DESCRIPTION})
set(CPACK_RPM_PACKAGE_DESCRIPTION ${CPACK_PACKAGE_DESCRIPTION})
set(CPACK_RPM_PACKAGE_AUTOREQ "0")
#set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA "${CMAKE_CURRENT_SOURCE_DIR}/Debian/postinst")
include(CPack)
################################################################################
# Source indexing for quick symbol lookup
# note that "glimpse" package must be installed.
# to exclude any directory or name from indexing,
# put the name in the glimpse_index/.glimpse_exclude
################################################################################
add_custom_target(index glimpseindex -n -H ./glimpse_index ${PROJECT_SOURCE_DIR}
COMMAND ${CMAKE_COMMAND} -P ${PROJECT_SOURCE_DIR}/glimpse_index/glim.cmake)
#this also shall generate the glimp command in the current project
# vim: set ts=4 sw=4 et smartindent:
================================================
FILE: README.md
================================================
# Mavimax Enduro/X® Core
## Build (including atmi/ubf tests) status
| OS | Status | OS | Status |OS | Status |
|----------|:-------------:|----------|:-------------:|----------|:-------------:|
| RHEL/Oracle Linux 9| [](http://www.silodev.com:9090/jenkins/job/endurox-ol9/) |Centos 6|[](http://www.silodev.com:9090/jenkins/job/endurox-centos6/)|FreeBSD 11|[](http://www.silodev.com:9090/jenkins/job/endurox-freebsd11/)|
|Oracle Linux 7|[](http://www.silodev.com:9090/jenkins/job/endurox-ol7/)|OSX 11.4|[](http://www.silodev.com:9090/jenkins/job/endurox-osx11_4/)|raspbian11_arv7l|[](http://www.silodev.com:9090/jenkins/job/endurox-raspbian10_arv7l/)|
|SLES 12|[](http://www.silodev.com:9090/jenkins/job/endurox-sles12/)|SLES 15|[](http://www.silodev.com:9090/jenkins/job/endurox-sles15/)|Solaris 10|[](http://www.silodev.com:9090/jenkins/job/endurox-solaris10-sparc/)|
|Solaris 11| [](http://www.silodev.com:9090/jenkins/job/endurox-solaris11_x86/)|Ubuntu 14.04| [](http://www.silodev.com:9090/jenkins/job/endurox-ubuntu14/)|Ubuntu 18.04| [](http://www.silodev.com:9090/jenkins/job/endurox-ubuntu18/)|
|RHEL/Oracle Linux 8| [](http://www.silodev.com:9090/jenkins/job/endurox-ol8/)|Ubuntu 22.04| [](http://www.silodev.com:9090/jenkins/job/endurox-ubuntu22/)|Ubuntu 20.04| [](http://www.silodev.com:9090/jenkins/job/endurox-ubuntu20/)|
`NOTE: Enduro/X for non-Linux versions is available only under commercial license from Mavimax SIA`
## Overview
Enduro/X is Open Source Middleware Platform for Distributed Transaction
Processing
It is modern, micro-services based middleware for writing distributed, open
systems (program consists of several executables) based applications. Thus
by using Enduro/X programmers do not have to worry about threads and concurrency
anymore, the load balancing and multi-CPU loading is done by Enduro/X middleware by it self,
administrator only have to determine how many copies of particular services should
be started. Of-course Enduro/X supports multi-threaded applications too, but now
system architects have a choice either to design multi-threaded executables or
just configure number of executables to start.
For local inter-process-communication (IPC) Enduro/X uses kernel memory based Posix
queues to avoid overhead of the TCP/IP protocol which is used in other middlewares
or REST based micro-service architectures. Thus this approach greatly increases
application speed, as kernel queues is basically a matter of block memory
copy from one process to another (by contrast of 7 layers of TCP/IP stack and
streaming nature of the sockets vs block copy).
Enduro/X provides SOA architecture for C/C++ applications and allows to cluster
application in fault tolerant way over multiple physical servers.
Enduro/X provides Oracle(R) Tuxedo(R) FML/FML32 library emulation,
including boolean expressions. Other Tuxedo specific APIs are supported,
such as tpforward() and work with distributed transactions (tpbegin(),
tpcommit(), etc.).
Platform provides X/Open XATMI and XA interfaces/APIs for C/C++ applications. Enduro/X can
at some level can be considered as replacement
for Oracle(R) Tuxedo(R), Jboss Blacktie (Narayan), Hitachi OpenTP1 and other XATMI middlewares.
Dual licensed under Affero General Public License Version 3 for use in Open
Source project or Commercial license Acquired from Mavimax Ltd
(https://www.mavimax.com),
EnduroX have bindings for:
- Golang (client & server)
- Java (client & server)
- Python 3 (client & server)
- PHP (client)
- Perl (client & server)
Enduro/X provides following features:
* Standards based APIs - SCA, The Open Group XATMI
Communication types - Synchronous, Asynchronous, Conversational, Publish/subscribe
* Typed buffers
* UBF (Unified Buffer Format) which provides emulation of Tuxedo's FML/FML32
format. UBF if high performance binary protocol buffer format. Buffer is
indexed by binary search on fixed data types. Types supported include BFLD_CHAR,
BFLD_SHORT, BFLD_LONG, BFLD_FLOAT, BFLD_DOUBLE, BFLD_STRING, BFLD_CARRAY,
BFLD_PTR, BFLD_UBF (recursive buffers), BFLD_VIEW
* STRING buffer format.
* CARRAY (byte array) buffer format.
* JSON buffer format, automatic conversion between JSON and UBF available.
* VIEW buffer (starting from version 5.0+). This offer C structure sending
between processes in cross platform way. Also this allows to map UBF
fields to VIEW fields, thus helping developer quicker to develop applications,
by combining UBF and VIEW buffers.
* Transaction Management - Global Transactions - Two-phase commit protocol - X/Open XA
* Clustering - on peer-to-peer basis
* Multi-threaded Event broker (also called publish and subscribe messaging)
* System process monitoring and self healing (pings and restarts)
* SOA Service cache. XATMI services can be cached to LMDB database. Resulting
that next call to service from any local client receives results
directly from cache (mainly from direct memory read).
* Dynamic re-configuration
* Custom server polling extensions
* XATMI sub-system is able to work without main application server daemon (ndrxd)
* Main application server daemon (ndrxd) can be restarted (if crashed).
When started back it enters in learning mode for some period of time,
in which in gathers information about system, what services are running,
etc. After learning =-period, it starts to do normal operations
* tpforward() call
* ATMI server threads may become clients, and can do tpcall()
* Extensive logging & debugging. Enduro/X logging can be configured per binary
with different log levels. As ATMI servers can be started outside of
appserver, it is possible to debug them from programming IDE or with
tools like valgrind.
* For quality assurance project uses automated unit-testing and integration-testing
* Built in ATMI service profiling.
* Environment variables can be updated for XATMI server processes with
out full application reboot.
* Generic client process monitor (cpm). Subsystem allows to start/stop/monitor
client executables. At client process crashes, cpm will start it back.
* Starting with version 5.2 Enduro/X provides configuration data encryption feature,
so that software which is built on top of Enduro/X may comply with
Payment Card Industry Data Security Standard (PCI/DSS).
* Application monitoring with TM_MIB interface. For example NetXMS.
* XA Driver for PostgreSQL.
* Fully functional buildserver, buildclient, buildtms tools.
* Provides server entry point _tmstartserver().
* Multi-threaded dispatcher support (mindispatchthreads/maxdispatchthreads),
including support for tpsvrthrinit() tpsvrthrdone() callbacks.
* Fast Pool Allocator - for performance reasons malloc results are cached,
so that blocks can be re-used instead of doing malloc again, thus Enduro/X
is gaining overall performance.
* Support of writing server daemons for multi-threaded servers
i.e. tpacall() to self advertised services during tpsvrinit().
* Support of Data Dependent Routing for UBF buffers.
* XATMI service auto-transactions are supported.
* For Linux and FreeBSD platforms call priorities are supported.
* Enduro/X logger now supports log-rotate calls (to re-open log handles) during
the runtime.
* Enduro/X logger now allows to change log levels on the fly for any Enduro/X
related process.
* Enduro/X provides Latent Command Framework (LCF), where developers via
plugin interface can publish CLI commands in xadmin tool, while any Enduro/X related
program can receive such commands via callback and perform custom action.
* Has tpsetcallinfo() and tpgetcallinfo() APIs.
* Product is extensively documented.
* Tool for automatic configuration migration from Oracle Tuxedo to Enduro/X.

# Load balancing

Supported operating system: GNU/Linux, starting from 2.6.12 kernel
(needed for POSIX Queues). Starting with Enduro/X Version 3.1.2 IBM AIX (6.1 and
7.1),
Oracle Solaris 11, MAC OS X (experimental) and Cygwin (experimental)
support is added. Supported compilers: gcc, LLVM clang, IBM xlC.
- Build and installation guides are located at: www.endurox.org/dokuwiki
- Support forum: http://www.endurox.org/projects/endurox/boards
- Binary builds (RPMs & DEBs) for various platforms are here:
https://www.mavimax.com/downloads
- Documentation available here: http://www.endurox.org/dokuwiki/doku.php
- Source corss reference: http://www.silodev.com/lxr/source
# Call/message forwarding
## Instead of doing calls to each server separately...

This is typciall way for example if doing micro-services with HTTP/REST.
You need to do the calls to each service separately. And that is extra
overhead to system (multiple returns) and the caller must orchestrate the all
calls.
## ...Enduro/X offers much effective way - tpforward() where request is
passed around the system

In this case the destination service orchestrates the system, it is up to
service to choose the next service which will continue the call processing.
The caller is not aware of final service which will do the reply back
(tpreturn()).
Note that service after doing "tpforward()" becomes idle and can consume next
call.
# High availability and self healing
Enduro/X is capable of detecting stalled/hanged XATMI servers and gracefully
can reboot them. The ping times are configurable on per server basis. In case
if main daemon dies, it is possible to configure special XATMI server named
"tprecover" which monitors "ndrxd" and vice versa, ndrxd can monitor tprecover.
Thus if any of these services are not cleanly shut down, then system will
heal it self, and boot service/daemons back.
The ndrxd learning mode is some period of time (configurable) in which ndrxd
will request all the system for active servers and their services,
to get back the view of the system and be in control. Note that system is able
to work even without ndrxd, but at that time no server healing
and management will be done.

# Real time system patching
It is possible to patch the Enduro/X system (update stateless XATMI servers)
without service interruption. This is achieved by following scheme:

# Monitoring
Enduro/X provides TM_MIB API for information reading. Out of the box NetXMS
monitoring suite uses this API to monitor application. Thus full featured
monitoring is possible. Presentation here (video):
[](https://www.youtube.com/watch?v=ubJk27bjKGE)
# Performance
Due to fact that Enduro/X uses memory based queues, performance numbers are
quite high:
## ATMI client calls server in async way (tpacall(), no reply from server)
 performance")
## Local one client calls server, and gets back response:
 performance")
## Multiple clients calls multiple servers
 performance")
## Single client calls single server via network (two app servers bridged)

performance")
## Persistent storage (message enqueue to disk via tpenqueue())
The number here are lower because messages are being saved to disk.
Also internally XA transaction is used, which also requires logging to stable
storage. This benchmark uses default Enduro/X setting for data
flushing to disk which is fflush() Unix system call. Fflush() does not guarantee data
consistence at power outage event. For fully guaranteed data consistence,
flags (FSYNC/FDATASYNC/DSYNC) can be set for XA resource. However expect much
lower TPS performance.
 performance")
## Tpcall cache benchmark
This benchmark shows the performance of cached XATMI service calls.
 cache performance")
# Migration from Oracle Tuxedo to Enduro/X
The migration is as simple as this (ideal scenario):
* Re-build the source code against Enduro/X.
* Migrate the configuration to Enduro/X format in seconds with [ubb2ex](doc/manpage/ubb2ex.adoc) tool.
* Test migrated application.
* Go live.
* See full [migration_tuxedo](doc/migration_tuxedo.adoc) guide.
Configuration migration example (ubb_config1 is Tuxedo UBB configuration file):
```
$ ubb2ex ubb_config1 -P ./test_dir
UBB2EX Tool
Enduro/X 7.5.36, build Dec 17 2021 22:33:46, using epoll for LINUX (64 bits)
Enduro/X Middleware Platform for Distributed Transaction Processing
Copyright (C) 2009-2016 ATR Baltic Ltd.
Copyright (C) 2017-2021 Mavimax Ltd. All Rights Reserved.
This software is released under one of the following licenses:
AGPLv3 (with Java and Go exceptions) or Mavimax license for commercial use.
$ cd test_dir/user90/conf
$ ls -1
app.test1.ini
ndrxconfig.test1.xml
settest1
$ source settest1
$ xadmin start -y
Enduro/X 7.5.36, build Dec 17 2021 22:33:46, using epoll for LINUX (64 bits)
Enduro/X Middleware Platform for Distributed Transaction Processing
Copyright (C) 2009-2016 ATR Baltic Ltd.
Copyright (C) 2017-2021 Mavimax Ltd. All Rights Reserved.
This software is released under one of the following licenses:
AGPLv3 (with Java and Go exceptions) or Mavimax license for commercial use.
* Shared resources opened...
* Enduro/X back-end (ndrxd) is not running
* ndrxd PID (from PID file): 57479
* ndrxd idle instance started.
exec cconfsrv -k C4Lwt7G4 -i 1 -e /tmp/test_dir/user90/log/cconfsrv.1.log -r -- :
process id=57481 ... Started.
exec cconfsrv -k C4Lwt7G4 -i 2 -e /tmp/test_dir/user90/log/cconfsrv.2.log -r -- :
process id=57482 ... Started.
exec tpadmsv -k C4Lwt7G4 -i 3 -e /tmp/test_dir/user90/log/tpadmsv.3.log -r -- :
process id=57483 ... Started.
exec tpadmsv -k C4Lwt7G4 -i 4 -e /tmp/test_dir/user90/log/tpadmsv.4.log -r -- :
process id=57484 ... Started.
exec tpevsrv -k C4Lwt7G4 -i 5 -e /tmp/test_dir/user90/log/tpevsrv.5.log -r -- :
process id=57485 ... Started.
exec tmsrv -k C4Lwt7G4 -i 8 -e /tmp/test_dir/user90/log/tmsrv.8.log -r -- -t1 -l /tmp/test_dir/user90/tmlogs/rm8 :
process id=57491 ... Started.
exec tmsrv -k C4Lwt7G4 -i 9 -e /tmp/test_dir/user90/log/tmsrv.9.log -r -- -t1 -l /tmp/test_dir/user90/tmlogs/rm8 :
process id=57503 ... Started.
exec tmqueue -k C4Lwt7G4 -i 40 -e /tmp/test_dir/user90/log/tmqueue.40.log -r -- -s1 -p10 -f10 :
...
```
# Releases
- Version 2.5.1 released on 18/05/2016. Support for transactional
persistent message queues. Provides APIs: tpenqueue(), tpdequeue() and
command line management tools. See doc/persistent_message_queues_overview.adoc,
doc/manpage/tmqueue.adoc, doc/manpage/xadmin.adoc, doc/manpage/q.config.adoc.
Use cases can be seen under atmitests/test028_tmq
- Version 3.1.2 released on 25/06/2016. Added support for other Unix systems.
Currently production grade support is provided for following operating systems:
GNU/Linux, FreeBSD, IBM AIX and Oracle Solaris. MAC OS X and Cygwin versions
are
considered as experimental. FreeBSD installation guides are located at
doc/freebsd_notes.adoc, AIX install guide: doc/aix_notes.adoc,
Solaris install guide: doc/solaris_notes.adoc and OS X guide:
doc/osx_notes.adoc. Also with this version lot of core processing bug fixes are
made.
- Version 3.2.1 released on 06/07/2016. Major UBF optimization. Now for each
data type memory offset is maintained. For fixed data types (short, long, char,
float, double) binary search is performend when field is read from buffer.
- Version 3.2.2 released on 15/07/2016. Bugfixes for UBF binary search. Added
UBF benchmarking scripts and documents.
- Version 3.3.1 released on 05/09/2016. Implemented common configuration engine
(can use ini files in alternative to environment variables, debug config and
persistent queue config).
- Version 3.3.2 released on 01/10/2016. Works on TP logger, user accessible
logging framework. Set of tplog\* functions.
- Version 3.3.5 released on 10/01/2017. Fixes for RPM build and install on
Red-hat enterprise linux platform.
- Version 3.3.6 released on 12/01/2017. Fixes for integration mode, changes in
tpcontinue().
- Version 3.4.1 released on 13/01/2017. New ATMI server flag for developer -
reloadonchange - if cksum change changed on binary issue sreload.
- Version 3.4.2 released on 20/01/2017. Network protocol framing moved from 2
bytes to 4 bytes.
- Version 3.4.3 released on 26/01/2017. Memory leak fixes for tmsrv and tmqueue
servers.
- Version 3.4.4 released on 26/01/2017. Works on documentation. Fixes on
PScript.
- Version 3.4.5 released on 14/02/2017. Fixes in generators.
- Version 3.5.1 released on 03/03/2017. Updates on tpreturn() - more correct
processing as in Tuxedo, free up return buffer + free up auto buffer.
- Version 3.5.2 released on 24/03/2017. Bug #105 fix. Abort transaction if it
was in "preparing" stage, and tmsrv loaded it from logfile. Meaning that caller
alaready do not wait for tpcommit() anymore and got inconclusive results, thus
better to abort.
- Version 3.5.3 released on 26/03/2017. Fixes for Solaris, Sun Studio (SUNPRO)
compiler
- Version 3.5.4 released on 01/03/2017. Fixed bug #108 - possible CPM crash
- Version 3.5.5 released on 23/03/2017. Works Feature #113 - mqd_t use as file
descriptor - for quick poll operations.
- Version 3.5.6 released on 02/04/2017. Fixed issues with possible deadlock for
poll mode on bridge service calls. Fixed issuw with 25 day uptime problem for
bridges on 32bit platfroms - the messages becomes expired on target server.
Issues: #112, #145, #140, #139, #113
- Version 3.5.7 release on 23/04/2017. Fixed Bug #148 (Bdelall corrupts ubf
buffer)
Bug #110 (tpbridge does not report connection status to ndrxd after ndrxd is
restarted for recovery)
- Version 3.5.9 released on 22/06/2017. Bug fix #160 - retry xa_start with
xa_close/xa_open. New env variable NDRX_XA_FLAGS, tag "RECON".
- Version 4.0.1 released on 29/06/2017. Multi-threaded bridge implementation.
tpnotify(), tpbroadcast(), tpsetunsol(), tpchkunsol() API implementation.
- Version 4.0.2 released on 19/07/2017. Fixed ndrxd core dump issue Bug #174.
- Version 4.0.3 released on 26/07/2017. Fixes of #176 #178. NDRX_DUMP, UBF_DUMP
fixes.
- Version 4.0.4 released on 29/07/2017. Feature #162 - added evt_mib.h
- Version 4.0.5 released on 01/08/2017. Feature #180 - refactoring code towards
ISO/IEC 9899:201x standard.
- Version 5.0.1 released on 21/08/2017. Feature #96 - Typed View support, Bug
#182 - fix in bridge protocol.
- Version 5.0.2 released on 22/08/2017. Bug #183
- Version 5.0.3 released on 22/08/2017. Bug #186
- Version 5.0.4 released on 22/08/2017. Bug #186
- Version 5.0.5 released on 27/08/2017. Bug #184, Bug #191, Bug #190, Bug #192,
Bug #193
- Version 5.0.6 released on 28/08/2017. Bug #195
- Version 5.0.7 released on 01/09/2017. Feature #161 - tmsrv database pings &
automatic reconnecting in case of network failures.
- Version 5.0.8 released on 17/09/2017. Works on dynamic view access. #99, #206,
#207, #210
- Version 5.0.9 released on 27/09/2017. (development) Works on #224
- Version 5.0.10 released on 13/10/2017. (stable) Feature #232, Feature #231,
-O2 optimization by default
- Version 5.1.1 released on 13/10/2017. (development) Feature #127, Bug #229,
Feature #230, Bug #234, Feature #244, Bug #243, Feature #248, Bug #240, Bug #238
- basically big message size support (over the 64K)
- Version 5.1.2 released on 18/10/2017. (stable) Bug #250
- Version 5.2.1 released on 18/12/2017. (development) Major work on support for PCI/DSS mandatory
configuration encryption. Introduction of plugin architecture (currently used for
crypto key providers). Implemented tpconvert() ATMI call. Now @global section for ini files are
read twice. Thus ini file can reference to previosly defined env/global variable.
Fixes: #261 Bug, #118 Feature, #237 Feature, #236 Bug, #245 Feature, #258
Support, #259 Support, #255 Bug, #254 Bug.
- Version 5.2.2 released on 21/12/2017. (stable) First stable version of Enduor/X 5.2. Rolled
- Version 5.2.4 released on 22/12/2017. (stable) Fixed Bug #268.
- Version 5.2.6 released on 02/01/2018. (stable) Happy New Year! Fixed Bug #269.
- Version 5.2.8 released on 26/01/2018. (stable) Fixed Bug #274 - too many open files,
when threaded logger using for multi-contexting (like go runtime)
- Version 5.2.10 released on 27/01/2018. (stable) Feature #275 - allow to mask
- Version 5.2.12 released on 27/01/2018. (stable) Feature #275 - fixes for server un-init (not critical)
- Version 5.2.14 released on 03/02/2018. (stable) Feature #278 - new fields for compiled connection id
- Version 5.2.15 released on 08/02/2018. (development) Feature #282 - new UBF api Baddfast()
- Version 5.2.16 released on 09/02/2018. (stable) Feature #282 - new UBF api Baddfast(), finished
documentation and added unit tests.
- Version 5.3.2 released on 25/03/2018 (stable) Fixes on Feature #272, Bug #291, Feature #287, Bug #290, Support #279
- Version 5.3.4 released on 26/03/2018 (stable) Feature #294, Bug #293
- Version 5.3.5 released on 28/03/2018 (Development) Working progress on Feature #295
- Version 5.3.6 released on 01/04/2018 (stable) Finished works on Feature #295
- Version 5.3.8 released on 06/04/2018 (stable) Implemented Feature #299 - new flag TPNOABORT
- Version 5.3.9 released on 09/04/2018 (development) Fixed Bug #300
- Version 5.3.10 released on 10/04/2018 (stable) Fixed Support #301
- Version 5.3.12 released on 12/04/2018 (stable) Support #302 - added last 8 chars of hostname to logfile
- Version 5.3.14 released on 21/04/2018 (stable) Bug #306
- Version 5.3.15 released on 23/04/2018 (development) Feature #307
- Version 5.3.16 released on 16/05/2018 (stable) Bug #317
- Version 5.3.17 released on 18/05/2018 (development) Feature #320 - cmdline tag for server in xml config
- Version 5.3.18 released on 27/06/2018 (stable) Bug #325
- Version 5.3.20 released on 10/10/2018 (stable) Backport Bug #321 fix to 5.3
- Version 6.0.1 released on 18/11/2018 (development) Latvia's 100th anniversary.
Major work on System V queue support, works for Java support, lots of bugs fixed.
Support #252, Feature #281, Feature #307, Support #310, Support #326,
Bug #330, Feature #331, Feature #333, Feature #334, Bug #338,
Bug #339, Bug #341, Bug #347, Support #350, Bug #351, Support #352, Bug #353
- Version 6.0.2 released on 02/12/2018 (stable) Bug #355 and other stability issues fixed
released with 6.0.1.
- Version 6.0.3 released on 16/12/2018 (development) Bug #364, Bug #360.
Added new command "ps" for xadmin, so that unit tests have unified access to
processing listings across all supported OSes.
- Version 6.0.5 released on 24/12/2018 (development) Feature #366
- Version 6.0.6 released on 08/01/2019 (stable) Marking stable release
- Version 6.0.8 released on 11/01/2019 (stable) Feature #372
- Version 6.0.10 released on 13/01/2019 (stable) Support #373, Bug #374
- Version 6.0.12 released on 16/01/2019 (stable) Bug #375, Bug #376
- Version 6.0.13 released on 18/01/2019 (development) Feature #181
- Version 6.0.14 released on 30/01/2019 (stable) Marking stable version
- Version 6.0.15 released on 01/01/2019 (development) Feature #380
- Version 6.0.17 released on 02/01/2019 (development) Feature #382, Feature #367, Support #303, Feature #271
- Version 6.0.19 released on 15/03/2019 (development) Bug #394, Feature #393
- Version 6.0.21 released on 19/03/2019 (development) Feature #397
- Version 6.0.23 released on 19/03/2019 (development) Additional work for Feature #397
- Version 6.0.25 released on 22/03/2019 (development) Feature #396
- Version 6.0.26 released on 25/03/2019 (stable) Support #400
- Version 6.0.27 released on 30/03/2019 (development) Feature #402
- Version 6.0.28 released on 11/06/2019 (stable) Feature #419
- Version 7.0.10 released on 03/11/2019 (stable) Release notes are here: https://www.endurox.org/news/18
- Version 7.0.12 released on 13/11/2019 (stable) Fixes on Bug #466
- Version 7.0.14 released on 13/11/2019 (stable) Fixes on Feature #470, Support #471, Support #473, Support #475
- Version 7.0.16 released on 16/11/2019 (stable) Fixes on Support #443, Support #493
- Version 7.0.18 released on 17/01/2020 (stable) Fixes on Bug #412, Support #505
- Version 7.0.20 released on 22/01/2020 (stable) Fixes on Support #502
- Version 7.0.22 released on 31/01/2020 (stable) Feature #509
- Version 7.0.24 released on 01/01/2020 (stable) Support #506
- Version 7.0.26 released on 09/03/2020 (stable) Support #528, Support, #527, Support #524,
Bug #523, Bug #521, Bug #515, Support #512, Bug #507, Support #503
- Version 7.0.28 released on 12/03/2020 (stable) Bug #530, Feature #313, Feature #536
- Version 7.0.30 released on 24/03/2020 (stable) Bug #537
- Version 7.0.32 released on 29/03/2020 (stable) Bug #544
- Version 7.0.34 released on 11/05/2020 (stable) Bug #501
- Version 7.0.36 released on 25/06/2020 (stable) Feature #262
- Version 7.5.1 released on 10/06/2020 (development) Feature #547, Support #553, Feature #545, Feature #540,
Feature #218, Feature #368, Feature #398, Feature #440, Feature #463, Feature #497, Feature #511, Feature #539,
Bug #542, Feature #549, Bug #576, Feature #577, Bug #580, Support #582
- Version 7.0.38 released on 03/07/2020 (stable) Bug #565
- Version 7.0.38 released on 03/07/2020 (stable) Bug #565, Bug #566
- Version 7.0.40 released on 11/07/2020 (stable) Bug #570, Support #571
- Version 7.0.42 released on 13/08/2020 (stable) Bug #572, Bug #578, Feature #581
- Version 7.5.2 released on 18/08/2020 (stable) First release version. Support #585, Bug #584, Bug #575
- Version 7.5.4 released on 21/09/2020 (stable) Feature #516, Bug #589, Support #590, Bug #592, Feature #588, Feature #598, Feature #594
- Version 7.5.6 released on 2/11/2020 (stable) Feature #603
- Version 7.5.8 released on 26/11/2020 (stable) Bug #610
- Version 7.0.44 released on 27/11/2020 (stable) Feature #606
- Version 7.0.44 released on 27/11/2020 (stable) Feature #606
- Version 7.0.44 released on 27/11/2020 (stable) Feature #606, Support #611
- Version 7.5.10 released on 27/11/2020 (stable) Feature #606
- Version 7.5.12 released on 16/12/2020 (stable) Support #612, Support #611
- Version 7.5.14 released on 21/12/2020 (stable) Feature #613
- Version 7.0.46 released on 17/01/2021 (stable) Support #623
- Version 7.5.16 released on 17/01/2021 (stable) Support #623
- Version 7.5.18 released on 18/02/2021 (stable) Support #633
- Version 7.5.20 released on 18/02/2021 (stable) Feature #213, Feature #286, Feature #401, Bug #608, Support #481, Support #644
- Version 7.5.22 released on 15/02/2021 (stable) Feature #640, Support #657
- Version 7.5.24 released on 11/04/2021 (stable) Bug #666, Support #667, Bug #675
- Version 7.5.26 released on 11/04/2021 (stable) Bug #602, Support #671, Support #677, Support #673, Bug #624
- Version 7.5.28 released on 30/05/2021 (stable) Support #634, Feature #699, Support #703, Bug #704, Feature #709, Feature #714,
Feature #715
- Version 7.5.30 released on 24/07/2021 (stable) Feature #717, Bug #719
- Version 7.5.32 released on 08/07/2021 (stable) Support #721, Bug #725
- Version 7.5.34 released on 10/09/2021 (stable) Feature #726, Feature #447, Bug #730, Support #729, Bug #734, Support #737
- Version 8.0.1 released on 09/10/2021 (development) Support #63, Support #265, Support #753, Support #752, Bug #701, Feature #211, Support #753, Support #752,
Feature #226, Bug #601, Feature #518, Support #622, Feature #517, Support #599, Support #554, Bug #555, Support #759, Bug #639, Support #267
- Version 7.5.36 released on 16/12/2021 (stable) Support #742, Bug #745, Bug #747, Support #748, Bug #749, Bug #750, Bug #796
- Version 8.0.4 released on 05/02/2022 (stable) Support #763, Feature #764, Support #765
- Version 8.0.6 prepared on 07/03/2022 (stable) Feature #767, Support #768, Support #769, Bug #771
- Version 7.0.48 released on 26/01/2021 (stable) Support #761
- Version 7.0.50 released on 12/11/2022 (stable) Bug #794
- Version 7.5.38 released on 12/11/2022 (stable) Bug #794, Bug #796, Bug #801
- Version 8.0.2 released on 26/01/2022 (stable) Marking initial release
- Version 8.0.4 released on 05/02/2022 (stable) Support #763, Feature #764, Support #765
- Version 8.0.6 prepared on 07/03/2022 (stable) Feature #767, Support #768, Support #769, Bug #771, Feature #772, Bug #774, Bug #775
- Version 8.0.8 prepared on 19/09/2023 (stable) Bug #789, Feature #792, Bug #794, Support #795, Bug #796, Bug #149,
Bug #798, Bug #738, Support #448, Bug #125, Bug #202, Bug #799, Bug #801, Support #802, Support #806
- Version 8.0.10 prepared on 10/08/2023 (stable) Bug #810, Bug #811, Bug #812, Feature #739
- Version 8.0.12 prepared on 19/01/2024 (stable) Bug #822, Bug #824, Bug #827, Feature #839
- Version 7.5.40 logged on 11/03/2024 (stable) Bug #827
- Version 8.0.14 logged on 08/08/2025 (stable) Bug #901
# Build configurations
## Configure make with:
$ cmake -DCMAKE_INSTALL_PREFIX:PATH=`pwd`/dist .
### Flags:
- To enable System V message queue, pass '-DDEFINE_SYSVQ=ON' to cmake (applies
to Linux only). Default on AIX and Solaris.
- To enable poll() use instead of epoll() in Linux use '-DDEFINE_FORCEPOLL=ON'
(applies to Linux only).
- To force use emulated message queue, add '-DDEFINE_FORCEEMQ=ON' (applies to
Linux only). Default on Macos.
- To disable GPG_ME, pass additional flag to cmake '-DDEFINE_DISABLEGPGME=ON'
- To disable documentation building add '-DDEFINE_DISABLEDOC=ON'
- To disable platform script building use '-DDEFINE_DISABLEPSCRIPT=ON'
- To do release build, use '-DDEFINE_RELEASEBUILD=ON'
- To log the memory allocation to user log add '-DNDRX_MEMORY_DEBUG=1'
- To trace of the Object-API use '-DNDRX_OAPI_DEBUG=1'
- To trace of the Semaphore handling use '-DNDRX_SEM_DEBUG=1'
- To enable test047 with Oracle PRO*C database access use '-DENABLE_TEST47=ON'
Note that *proc* must be in path and ORACLE_HOME must be set. Also Oracle DB
libraries must be present in LD_LIBRARY_PATH (or equivalent environment for
target OS).
- To force memory alignment usage, use '-DDEFINE_ALIGNMENT_FORCE=1', by default
on for SPARC cpus.
- To enable address sanitizer for GCC/Clang on supported hardware platforms,
use '-DDEFINE_SANITIZE=1'
- To enable PostgreSQL XA Driver build use '-DENABLE_POSTGRES=ON'
- To disable PostgreSQL ECPG Driver build use '-DDISABLE_ECPG=ON' (for certain
Operating systems ECPG, postgres-devel package is missing, thus let only pq
driver to build)
- To enable strict mutex checking on GNU platform, use '-DMUTEX_DEBUG=ON' (for
GNU platforms only)
- To force use AIX System V Polling on AIX and Linux (for Linux dev build only, non functional),
add '-DDEFINE_SVAPOLL=ON'.
================================================
FILE: cmake_uninstall.cmake.in
================================================
if(NOT EXISTS "@CMAKE_CURRENT_BINARY_DIR@/install_manifest.txt")
message(FATAL_ERROR "Cannot find install manifest: @CMAKE_CURRENT_BINARY_DIR@/install_manifest.txt")
endif(NOT EXISTS "@CMAKE_CURRENT_BINARY_DIR@/install_manifest.txt")
file(READ "@CMAKE_CURRENT_BINARY_DIR@/install_manifest.txt" files)
string(REGEX REPLACE "\n" ";" files "${files}")
foreach(file ${files})
message(STATUS "Uninstalling $ENV{DESTDIR}${file}")
if(IS_SYMLINK "$ENV{DESTDIR}${file}" OR EXISTS "$ENV{DESTDIR}${file}")
exec_program(
"@CMAKE_COMMAND@" ARGS "-E remove \"$ENV{DESTDIR}${file}\""
OUTPUT_VARIABLE rm_out
RETURN_VALUE rm_retval
)
if(NOT "${rm_retval}" STREQUAL 0)
message(FATAL_ERROR "Problem when removing $ENV{DESTDIR}${file}")
endif(NOT "${rm_retval}" STREQUAL 0)
else(IS_SYMLINK "$ENV{DESTDIR}${file}" OR EXISTS "$ENV{DESTDIR}${file}")
message(STATUS "File $ENV{DESTDIR}${file} does not exist.")
endif(IS_SYMLINK "$ENV{DESTDIR}${file}" OR EXISTS "$ENV{DESTDIR}${file}")
endforeach(file)
gitextract_ynbbc8ti/ ├── .git/ │ ├── HEAD │ ├── config │ ├── description │ ├── hooks/ │ │ ├── applypatch-msg.sample │ │ ├── commit-msg.sample │ │ ├── fsmonitor-watchman.sample │ │ ├── post-update.sample │ │ ├── pre-applypatch.sample │ │ ├── pre-commit.sample │ │ ├── pre-merge-commit.sample │ │ ├── pre-push.sample │ │ ├── pre-rebase.sample │ │ ├── pre-receive.sample │ │ ├── prepare-commit-msg.sample │ │ ├── push-to-checkout.sample │ │ ├── sendemail-validate.sample │ │ └── update.sample │ ├── index │ ├── info/ │ │ └── exclude │ ├── logs/ │ │ ├── HEAD │ │ └── refs/ │ │ ├── heads/ │ │ │ └── master │ │ └── remotes/ │ │ └── origin/ │ │ └── HEAD │ ├── objects/ │ │ └── pack/ │ │ ├── pack-ac0e6b253efd0968978b6cfa07966fb2fd6c8472.idx │ │ ├── pack-ac0e6b253efd0968978b6cfa07966fb2fd6c8472.pack │ │ ├── pack-ac0e6b253efd0968978b6cfa07966fb2fd6c8472.promisor │ │ ├── pack-ac0e6b253efd0968978b6cfa07966fb2fd6c8472.rev │ │ ├── pack-b7dd7c6b8faf35a4d673846f8e7cf364a2d6e697.idx │ │ ├── pack-b7dd7c6b8faf35a4d673846f8e7cf364a2d6e697.pack │ │ ├── pack-b7dd7c6b8faf35a4d673846f8e7cf364a2d6e697.promisor │ │ └── pack-b7dd7c6b8faf35a4d673846f8e7cf364a2d6e697.rev │ ├── packed-refs │ ├── refs/ │ │ ├── heads/ │ │ │ └── master │ │ └── remotes/ │ │ └── origin/ │ │ └── HEAD │ └── shallow ├── .gitignore ├── CMakeLists.txt ├── README.md └── cmake_uninstall.cmake.in
Condensed preview — 38 files, each showing path, character count, and a content snippet. Download the .json file or copy for the full structured content (85K chars).
[
{
"path": ".git/HEAD",
"chars": 23,
"preview": "ref: refs/heads/master\n"
},
{
"path": ".git/config",
"chars": 351,
"preview": "[core]\n\trepositoryformatversion = 1\n\tfilemode = true\n\tbare = false\n\tlogallrefupdates = true\n[remote \"origin\"]\n\turl = htt"
},
{
"path": ".git/description",
"chars": 73,
"preview": "Unnamed repository; edit this file 'description' to name the repository.\n"
},
{
"path": ".git/hooks/applypatch-msg.sample",
"chars": 478,
"preview": "#!/bin/sh\n#\n# An example hook script to check the commit log message taken by\n# applypatch from an e-mail message.\n#\n# T"
},
{
"path": ".git/hooks/commit-msg.sample",
"chars": 896,
"preview": "#!/bin/sh\n#\n# An example hook script to check the commit log message.\n# Called by \"git commit\" with one argument, the na"
},
{
"path": ".git/hooks/fsmonitor-watchman.sample",
"chars": 4726,
"preview": "#!/usr/bin/perl\n\nuse strict;\nuse warnings;\nuse IPC::Open2;\n\n# An example hook script to integrate Watchman\n# (https://fa"
},
{
"path": ".git/hooks/post-update.sample",
"chars": 189,
"preview": "#!/bin/sh\n#\n# An example hook script to prepare a packed repository for use over\n# dumb transports.\n#\n# To enable this h"
},
{
"path": ".git/hooks/pre-applypatch.sample",
"chars": 424,
"preview": "#!/bin/sh\n#\n# An example hook script to verify what is about to be committed\n# by applypatch from an e-mail message.\n#\n#"
},
{
"path": ".git/hooks/pre-commit.sample",
"chars": 1649,
"preview": "#!/bin/sh\n#\n# An example hook script to verify what is about to be committed.\n# Called by \"git commit\" with no arguments"
},
{
"path": ".git/hooks/pre-merge-commit.sample",
"chars": 416,
"preview": "#!/bin/sh\n#\n# An example hook script to verify what is about to be committed.\n# Called by \"git merge\" with no arguments."
},
{
"path": ".git/hooks/pre-push.sample",
"chars": 1374,
"preview": "#!/bin/sh\n\n# An example hook script to verify what is about to be pushed. Called by \"git\n# push\" after it has checked t"
},
{
"path": ".git/hooks/pre-rebase.sample",
"chars": 4898,
"preview": "#!/bin/sh\n#\n# Copyright (c) 2006, 2008 Junio C Hamano\n#\n# The \"pre-rebase\" hook is run just before \"git rebase\" starts d"
},
{
"path": ".git/hooks/pre-receive.sample",
"chars": 544,
"preview": "#!/bin/sh\n#\n# An example hook script to make use of push options.\n# The example simply echoes all push options that star"
},
{
"path": ".git/hooks/prepare-commit-msg.sample",
"chars": 1492,
"preview": "#!/bin/sh\n#\n# An example hook script to prepare the commit log message.\n# Called by \"git commit\" with the name of the fi"
},
{
"path": ".git/hooks/push-to-checkout.sample",
"chars": 2783,
"preview": "#!/bin/sh\n\n# An example hook script to update a checked-out tree on a git push.\n#\n# This hook is invoked by git-receive-"
},
{
"path": ".git/hooks/sendemail-validate.sample",
"chars": 2308,
"preview": "#!/bin/sh\n\n# An example hook script to validate a patch (and/or patch series) before\n# sending it via email.\n#\n# The hoo"
},
{
"path": ".git/hooks/update.sample",
"chars": 3650,
"preview": "#!/bin/sh\n#\n# An example hook script to block unannotated tags from entering.\n# Called by \"git receive-pack\" with argume"
},
{
"path": ".git/info/exclude",
"chars": 240,
"preview": "# git ls-files --others --exclude-from=.git/info/exclude\n# Lines that start with '#' are comments.\n# For a project mostl"
},
{
"path": ".git/logs/HEAD",
"chars": 188,
"preview": "0000000000000000000000000000000000000000 8eac94dbe90ea432453ea42168bf116af5d4ed8f appuser <appuser@7c99e0e64a07.(none)> "
},
{
"path": ".git/logs/refs/heads/master",
"chars": 188,
"preview": "0000000000000000000000000000000000000000 8eac94dbe90ea432453ea42168bf116af5d4ed8f appuser <appuser@7c99e0e64a07.(none)> "
},
{
"path": ".git/logs/refs/remotes/origin/HEAD",
"chars": 188,
"preview": "0000000000000000000000000000000000000000 8eac94dbe90ea432453ea42168bf116af5d4ed8f appuser <appuser@7c99e0e64a07.(none)> "
},
{
"path": ".git/objects/pack/pack-ac0e6b253efd0968978b6cfa07966fb2fd6c8472.promisor",
"chars": 59,
"preview": "8eac94dbe90ea432453ea42168bf116af5d4ed8f refs/heads/master\n"
},
{
"path": ".git/objects/pack/pack-b7dd7c6b8faf35a4d673846f8e7cf364a2d6e697.promisor",
"chars": 0,
"preview": ""
},
{
"path": ".git/packed-refs",
"chars": 114,
"preview": "# pack-refs with: peeled fully-peeled sorted \n8eac94dbe90ea432453ea42168bf116af5d4ed8f refs/remotes/origin/master\n"
},
{
"path": ".git/refs/heads/master",
"chars": 41,
"preview": "8eac94dbe90ea432453ea42168bf116af5d4ed8f\n"
},
{
"path": ".git/refs/remotes/origin/HEAD",
"chars": 32,
"preview": "ref: refs/remotes/origin/master\n"
},
{
"path": ".git/shallow",
"chars": 41,
"preview": "8eac94dbe90ea432453ea42168bf116af5d4ed8f\n"
},
{
"path": ".gitignore",
"chars": 2126,
"preview": "# Ignore all\n*\n# Unignore all with extensions\n!*.*\n# Unignore all dirs\n!*/\ninstall_manifest.txt\nnbproject\ninclude/ndrx_c"
},
{
"path": "CMakeLists.txt",
"chars": 15895,
"preview": "##\n## @brief Enduro Execution platform main Make descriptor\n##\n## @file CMakeLists.txt\n##\n## ---------------------------"
},
{
"path": "README.md",
"chars": 32972,
"preview": "# Mavimax Enduro/X® Core\n\n## Build (including atmi/ubf tests) status\n\n| OS | Status | OS | Status"
},
{
"path": "cmake_uninstall.cmake.in",
"chars": 1035,
"preview": "if(NOT EXISTS \"@CMAKE_CURRENT_BINARY_DIR@/install_manifest.txt\")\n message(FATAL_ERROR \"Cannot find install manifest: @C"
}
]
// ... and 7 more files (download for full content)
About this extraction
This page contains the full source code of the endurox-dev/endurox GitHub repository, extracted and formatted as plain text for AI agents and large language models (LLMs). The extraction includes 38 files (77.5 KB), approximately 23.8k tokens. Use this with OpenClaw, Claude, ChatGPT, Cursor, Windsurf, or any other AI tool that accepts text input. You can copy the full output to your clipboard or download it as a .txt file.
Extracted by GitExtract — free GitHub repo to text converter for AI. Built by Nikandr Surkov.